#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tkhost.h>

int main(int argc,char *argv[])
{
  OUTMESS *outbuff;
  OUTMESS ob;
  PLANETDATA *planbuff;
  PLANET_NAME nameh;
  int k,m;
  char *d,*d1;
  char *tx;
  int n;
  bool t;
  char ifile[80];
  XString nn;
  FILE *log;

  set_game_dir(argv[1]);

  strcpy(ifile,argv[1]);
  strcat(ifile,"/renamep.log");

  log=fopen(ifile,"wt");

  m=num_outmess();
  if (m>0) {
    outbuff=read_all_outmess();
    if (outbuff) {
      for (k=1;k<=m;k++) {
        t=false;
        fprintf(log,"Message #%d:\n",k);
        tx=(char *)malloc(outbuff[k].sMessage.Len()+1);
        strcpy(tx,outbuff[k].sMessage.Lower());
        d=strstr(tx,"renamep ");
        while (d!=NULL) {
          d1=NULL;
          d+=7; // skip over "renamep "
          n=atoi(d); // and get planet #
          if (n>0 && n<501) {
            planbuff=read_planetdata(n);
            d=strstr(d,"\r");
            d++;
            d1=strstr(d,"\r");
            if (planbuff->sCode.Lower()=="ren") { // must be set
              strcpy(tx,outbuff[k].sMessage);
              if (d1!=NULL) *d1=0;
              fprintf(log,"Renaming planet %d to %s.\n",n,d);
              nameh.sName=d;
              write_planet_name(n,&nameh);
              ob.iTo=planbuff->wOwner;
              ob.sMessage="Planet renaming:\r\r";
              ob.sMessage|="Planet #";
              sprintf(tx,"%d",n);
              ob.sMessage|=tx;
              ob.sMessage|=" is now known as\r";
              ob.sMessage|=nameh.sName;
              write_outmess(0,&ob);
              t=true;
            }
          }
          if (d1!=NULL) { // more to follow
            d=d1+1;
            strcpy(tx,outbuff[k].sMessage.Lower());
            d=strstr(d,"renamep ");
          } else {
            d=NULL;
          }
        };
        free(tx);
        if (t) {
          del_outmess(k);
          fprintf(log,"Deleting message %d\n",k);
        }
      }
    }
  }
  fclose(log);
  return 0;
}
